
#include <reg51.h>
#include <api.h>

#define uchar unsigned char

/***************************************************/
#define TX_ADR_WIDTH   5 
#define TX_PLOAD_WIDTH 4  
#define LED P2

uchar code TX_ADDRESS[TX_ADR_WIDTH] = {0x34,0x43,0x10,0x10,0x01};  
uchar RX_BUF[TX_PLOAD_WIDTH];
uchar TX_BUF[TX_PLOAD_WIDTH];
uchar flag;
uchar DATA = 0x01;
uchar bdata sta;
sbit  RX_DR	 = sta^6;
sbit  TX_DS	 = sta^5;
sbit  MAX_RT = sta^4;
/**************************************************/


void init_io(void)
{
	CE  = 0;        // stand by
	CSN = 1;        // disabel SPI
	SCK = 0;        // SPI SCK to low
	IRQ = 1;        
	LED = 0xff;		 // shun dowm led
}
/**************************************************/
void delay_ms(uchar x)
{
    uchar i, j;
    i = 0;
    for(i=0; i<x; i++)
    {
       j = 250;
       while(--j);
	   j = 250;
       while(--j);
    }
}
/**************************************************/
uchar SPI_RW(uchar byte)
{
	uchar i;
   	for(i=0; i<8; i++)         
   	{
   		MOSI = (byte & 0x80); 
   		byte <<= 1;             
   		SCK = 1;                
   		byte |= MISO;       	
   		SCK = 0;            
   	}
    return(byte);           
}
/**************************************************/
uchar SPI_RW_Reg(uchar reg, uchar value)
{
	uchar status;
  	CSN = 0;                 
  	status = SPI_RW(reg);    
  	SPI_RW(value);           
  	CSN = 1;                   
  	return(status);            
}
/**************************************************/
uchar SPI_Read(uchar reg)
{
	uchar reg_val;
  	CSN = 0;                  
  	SPI_RW(reg);              
  	reg_val = SPI_RW(0);      
  	CSN = 1;                   
  	return(reg_val);           
}
/**************************************************/
uchar SPI_Read_Buf(uchar reg, uchar * pBuf, uchar bytes)
{
	uchar status, i;
  	CSN = 0;                   
  	status = SPI_RW(reg);     
  	for(i=0; i<bytes; i++)
    	pBuf[i] = SPI_RW(0);   
  	CSN = 1;                    
  	return(status);          
}
/**************************************************/
uchar SPI_Write_Buf(uchar reg, uchar * pBuf, uchar bytes)
{
	uchar status, i;
  	CSN = 0;                   
  	status = SPI_RW(reg);      
  	for(i=0; i<bytes; i++)
    	SPI_RW(pBuf[i]);        
  	CSN = 1;                   
  	return(status);             
/**************************************************/
void RX_Mode(void)
{
	CE = 0;
  	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  
  	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);             
  	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);         
  	SPI_RW_Reg(WRITE_REG + RF_CH, 40);               
  	SPI_RW_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  
  	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);            
  	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);             
  	CE = 1;                                          
}
/**************************************************/
void TX_Mode(uchar * BUF)
{
	CE = 0;
  	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);     
  	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  
  	SPI_Write_Buf(WR_TX_PLOAD, BUF, TX_PLOAD_WIDTH);                 
  	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      
  	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);   
  	SPI_RW_Reg(WRITE_REG + SETUP_RETR, 0x0a); 
  	SPI_RW_Reg(WRITE_REG + RF_CH, 40);        
  	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);    
  	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);      
	CE = 1;
}
/**************************************************/
uchar Check_ACK(bit clear)
{
	while(IRQ);
	sta = SPI_RW(NOP);                   
	if(MAX_RT)
		if(clear)                         
			SPI_RW(FLUSH_TX);
	SPI_RW_Reg(WRITE_REG + STATUS, sta);  
	IRQ = 1;
	if(TX_DS)
		return(0x00);
	else
		return(0xff);
}
/**************************************************/
void CheckButtons()
{
	P3 |= 0x00;
	if(!(P3 & 0x01))		           
	{
		delay_ms(20);
		if(!(P3 & 0x01))			   
		{
			TX_BUF[0] = ~DATA;        
			TX_Mode(TX_BUF);			
			LED = ~DATA;		       
			Check_ACK(1);             
			delay_ms(250);
			delay_ms(250);
			LED = 0xff;			       
			RX_Mode();			       
			while(!(P3 & 0x01));
			DATA <<= 1;
			if(!DATA)
				DATA = 0x01;
		}
	}
}

/**************************************************/
void main(void)
{
	init_io();		             
	RX_Mode();		             
	while(1)
	{
		CheckButtons();          
		sta = SPI_Read(STATUS);	  
	    if(RX_DR)				  
		{
			SPI_Read_Buf(RD_RX_PLOAD, RX_BUF, TX_PLOAD_WIDTH);  
			flag = 1;
		}
		SPI_RW_Reg(WRITE_REG + STATUS, sta);  
		if(flag)		         
		{
			flag = 0;		     
			LED = RX_BUF[0];	   
			delay_ms(250);
			delay_ms(250);
  			LED = 0xff;		      
		}
	}
}
/**************************************************/