#include <msp430x14x.h>
//==============================================================================
#define  RF24L01_CE_0        P3OUT &=~BIT1         
#define  RF24L01_CE_1        P3OUT |= BIT1        
//=============================RF24L01_CSN˿==================================
#define  RF24L01_CSN_0       P3OUT &=~BIT3         
#define  RF24L01_CSN_1       P3OUT |= BIT3     
//=============================RF24L01_SCK======================================
#define  RF24L01_SCK_0       P3OUT &=~BIT2      
#define  RF24L01_SCK_1       P3OUT |= BIT2   
//=============================MISO˿=========================================
#define  RF24L01_MISO_0      P3OUT &=~BIT0
#define  RF24L01_MISO_1      P3OUT |= BIT0
//============================= RF24L01_MOSI˿================================
#define  RF24L01_MOSI_0      P2OUT &=~BIT6
#define  RF24L01_MOSI_1      P2OUT |= BIT6
//==========================IRQ״̬============================================
#define  RF24L01_IRQ_0       P2OUT &=~BIT7       
#define  RF24L01_IRQ_1       P2OUT |= BIT7
//==============================================================================
#define  LED1_0              P6OUT &=~BIT1          //0
#define  LED1_1              P6OUT |= BIT1          //1
#define  LED2_0              P6OUT &=~BIT2          //0
#define  LED2_1              P6OUT |= BIT2          //1
//==================================BELL========================================
#define  BELL_0     P6OUT &=~BIT3          //0
#define  BELL_1     P6OUT |= BIT3          //1
//===================================LCD========================================
#define  DataDir             P4DIR              
#define  DataPort            P4OUT	
//==============================================================================
#define  Busy	             0x80
//==============================================================================
#define  CtrlDir             P6DIR
#define  CLR_RS              P6OUT&=~BIT6;         //RS = P6.6	
#define  SET_RS              P6OUT|=BIT6;	
//==============================================================================
#define  CLR_RW              P6OUT&=~BIT5;	  //RW = P6.5
#define  SET_RW              P6OUT|=BIT5;	
//==============================================================================
#define  CLR_EN              P6OUT&=~BIT4;	  //EN = P6.4
#define  SET_EN              P6OUT|=BIT4;	
//==========================NRF24L01============================================
#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  32  	// 32 TX payload
#define RX_PLOAD_WIDTH  32  	// 32 uints TX payload
//=========================NRF24L01Ĵָ===================================
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP1            0xFF  	// 
//========================SPI(nRF24L01)Ĵַ===============================
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
//=============================RF24l01״̬=====================================
char  TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
char  RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ
char  sta;
char  tf, MARK,TxBuf[32];
//******************************************************************************
//ϵͳʼ
//******************************************************************************
void InitSys()
{
   unsigned int iq0;
   _DINT();
   BCSCTL1 &=~XT2OFF;
   do
   {
      IFG1 &= ~OFIFG;							// ʧЧ־
      for (iq0 = 0xFF; iq0 > 0; iq0--);	// ʱȴXT2
   }
   while ((IFG1 & OFIFG) != 0);		// жXT2Ƿ		
   BCSCTL2 =SELM1+SELS;                // MCLK,SMCLKʱΪXT2		
}
//===========================LED˿=======================================
void LED_IO_set(void)
{    
        P6DIR |= 0x06;   P6SEL&=0xf9;        
}
//==============================================================================
void BELL_IO_set(void)
{    
        P6DIR |= 0x08;   P6SEL&=0xF7;        
}
//==========================˿=======================================
void KEY_IO_set(void)
{    
        P1DIR &= 0xfc;   P1SEL&=0xfc;        
}
//===========================RF24L01˿==========================================
void RF24L01_IO_set(void)
{
      P2DIR &= 0x7f;    P2DIR |= 0x40;  P2SEL&=0x3F;   P2IE=P2IE&0x3f;
      P3DIR &= 0xFE;    P3DIR |= 0x0E;  P3SEL&=0xF0;
}
//==============================================================================
void LCD_IO_set()
  {
    CtrlDir |= 0x70;                 //߶˿Ϊ״̬ 
    DataDir  = 0xFF;                 //ݶ˿Ϊ״̬
    P4SEL=0x00;                    //P4ΪһIO   
    P6SEL&=0x8f;                  //P6ΪһIO  
  }
//========================ʱԼ5ms=============================================
void ms_delay(void)
{ 
   unsigned int i=40000;
    while (i != 0)
    {
        i--;
    }
}
//========================================ʱ================================
void Delay(int s)
{
	unsigned int i,j;
	for(i=0; i<s; i++);
	for(j=0; j<s; j++);
}
//******************************************************************************************
//ʱ
//******************************************************************************************
void inerDelay_us(int n)
{
	for(;n>0;n--);
}
//==============================================================================
//uint SPI_RW(uint uchar)
//ܣNRF24L01SPIдʱ
//******************************************************************************
char SPI_RW(char data)
{
	char i,temp=0;
   	for(i=0;i<8;i++) // output 8-bit
   	{
	if((data & 0x80)==0x80)
	{
		RF24L01_MOSI_1;         // output 'uchar', MSB to MOSI
	}
	else
	{
	 	RF24L01_MOSI_0; 
	}	
//==============================================================================
		data = (data << 1);            // shift next bit into MSB..
		temp<<=1;
		RF24L01_SCK_1;                // Set SCK high..
		if((P3IN&0x01)==0x01)temp++;         // capture current MISO bit
		RF24L01_SCK_0;              // ..then set SCK low again
   	}
    return(temp);           		  // return read uchar
}
//****************************************************************************************************
//uchar SPI_Read(uchar reg)
//ܣNRF24L01SPIʱ
//****************************************************************************************************
char SPI_Read(char reg)
{
	char reg_val;
	RF24L01_CSN_0;           // CSN low, initialize SPI communication...
	SPI_RW(reg);            // Select register to read from..
	reg_val = SPI_RW(0);    // ..then read registervalue
	RF24L01_CSN_1;         // CSN high, terminate SPI communication
	return(reg_val);       // return register value
}
//****************************************************************************************************/
//ܣNRF24L01дĴ
//****************************************************************************************************/
char SPI_RW_Reg(char reg, char value)
{
	char status1;
	RF24L01_CSN_0;                   // CSN low, init SPI transaction
	status1 = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	RF24L01_CSN_1;                   // CSN high again
	return(status1);            // return nRF24L01 status uchar
}
//****************************************************************************************************/
//uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
//: ڶݣregΪĴַpBufΪݵַucharsݵĸ
//****************************************************************************************************/
char SPI_Read_Buf(char reg, char *pBuf, char chars)
{
	char status2,uchar_ctr;
	RF24L01_CSN_0;                    		// Set CSN low, init SPI tranaction
	status2 = SPI_RW(reg);       		// Select register to write to and read status uchar
	for(uchar_ctr=0;uchar_ctr<chars;uchar_ctr++)
        {
	pBuf[uchar_ctr] = SPI_RW(0);    // 
        }
	RF24L01_CSN_1;                           
	return(status2);                    // return nRF24L01 status uchar
}
//*********************************************************************************************************
//uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
//: дݣΪĴַpBufΪдݵַucharsдݵĸ
//*********************************************************************************************************/
char SPI_Write_Buf(char reg, char *pBuf, char chars)
{
	char status1,uchar_ctr;
	RF24L01_CSN_0;             //SPIʹ       
	status1 = SPI_RW(reg);   
	for(uchar_ctr=0; uchar_ctr<chars; uchar_ctr++) //
        {
	SPI_RW(*pBuf++);
        }
	RF24L01_CSN_1;           //رSPI
	return(status1);    		  // 
}
//****************************************************************************************************/
//void SetRX_Mode(void)
//ܣݽ 
//****************************************************************************************************/
void SetRX_Mode(void)
{
	RF24L01_CE_0 ;
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);   		// IRQշжӦ16λCRC	
	RF24L01_CE_1; 
	inerDelay_us(1000);//עⲻ̫С
}
//******************************************************************************************************/
//unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
//ܣݶȡrx_bufջ
//******************************************************************************************************/
char nRF24L01_RxPacket(char* rx_buf)
{
    char revale=0;
	sta=SPI_Read(STATUS);	     // ȡ״̬Ĵжݽ״		
	if(sta&0x40)                 // жǷյ
	{
	    RF24L01_CE_0 ; 			//SPIʹ
	    SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
	    revale =1;			//ȡɱ־
	}
	SPI_RW_Reg(WRITE_REG+STATUS,sta);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	return revale;
}
//***********************************************************************************************************
//void nRF24L01_TxPacket(char * tx_buf)
//ܣ tx_buf
//**********************************************************************************************************/
void nRF24L01_TxPacket(char * tx_buf)
{
	RF24L01_CE_0 ;			//StandBy Iģʽ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
        SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC
	RF24L01_CE_1;		 //øCEݷ
	inerDelay_us(600);
}
//****************************************************************************************
//NRF24L01ʼ
//***************************************************************************************/
void init_NRF24L01(void)
{
        inerDelay_us(100);
 	RF24L01_CE_0 ;    // chip enable
 	RF24L01_CSN_1;   // Spi disable 
 	RF24L01_SCK_0;   // Spi clock line init high
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + RF_CH, 0);        //   ŵΪ2.4GHZշһ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   //÷Ϊ1MHZ书Ϊֵ0dB
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);   // IRQշжӦ16λCRC	}
}
//======================ڳʼ==============================================
void init_uart0(void)
  {
//====================ڹģʽ========================================
    U0CTL=0x00;      // U0CTL0ͨЭ顢ͨģʽУλãUART0
    U0CTL +=CHAR;    //(CHAR=0x10)CHAR=0ʱλ7λݣ CHAR=1ʱΪ8λ 
                     //ҪУ飬λΪ8λ޷첽UARTͨţUART
//====================ڷͲ========================================
    U0TCTL=0x00;     //U0TCTL0͹ܲ
    U0TCTL +=SSEL0;  //ʷѡACLK 
                     //#define SSEL1  (0x20)       #define SSEL0  (0x10)
//====================ڲ9600====================================
//===================ʼ㹫ʽ=BRCLK/UBR+M7+M6++M0/8
    UBR0_0=0x03;     //UBR0_0Ϊ0ֵ͵ַ 
    UBR1_0=0x00;     //UBR1_0Ϊ0ָߵַ 
    UMCTL_0=0x4A;    //UBR1_0Ϊ0Сָߵַ 
//===================շʹܿ=========================================
    ME1 |= UTXE0;    //0͹ʹ
    ME1 |= URXE0;    //0չʹ    
//===================жʹܿ=========================================
    IE1 |= URXIE0;   //0жʹ
//   IE1 |= UTXIE0;   //0жʹ
//===================˿ڵڶʹ=========================================
    P3SEL |=BIT4;    //P34ΪUART0 TXD
    P3SEL |=BIT5;    //P35ΪUART0 RXD
    P3DIR |=BIT4;    //P34Ϊ
    _EINT();        //ȫжϿƣҪ򿪣α
  }
//======================ڽжϷ====================================
#if __VER__ < 200
  interrupt [UART0RX_VECTOR] void  UART0_RX_ISR(void)
#else
  #pragma vector=UART0RX_VECTOR
  __interrupt void UART0_RX_ISR(void)
#endif
{
  while ((IFG1 & URXIFG0) == 1);//жϱ־        
  if((U0RCTL&RXERR)==0)          //ûнճ
  {
  MARK = RXBUF0; // RXBUF0 to TXBUF0
  //delay(500);
  TXBUF0=MARK;
  IFG1=IFG1&0xef;
  }
}
//=============================================================================
main()
{     
      WDTCTL = WDTPW + WDTHOLD; //ֹŹ
      LED_IO_set();
      BELL_IO_set();
      KEY_IO_set(); 
      RF24L01_IO_set();
      InitSys();
      init_NRF24L01() ;
      init_uart0();
      LED1_1;LED2_1; BELL_1; 
      while(1)
      {
      if(MARK==48)		//00ASCIIΪ48
	{
	TxBuf[0]=0x01;
        tf=1; LED1_1; BELL_0; 
	}
    if(MARK==49)		//м1
	{
	TxBuf[0]=0x11;
        tf=1; LED1_0;  BELL_1; 
        }
    if(MARK==50)		//м2
	{
	TxBuf[0]=0x21;
        tf=1; LED1_1;BELL_0;
        }	
    if(MARK==51)		//м3
	{
	TxBuf[0]=0x31;
        tf=1;LED1_0; BELL_1;
	}
    if(MARK==52)		//м4
	{
	TxBuf[0]=0x41;
        tf=1; LED2_0; BELL_0; 
	}
    if(MARK==53)	        //м5
	{
	TxBuf[0]=0x51;
        tf=1; LED2_1; BELL_1;
	}
    if(MARK==54)		//м6
	{
	TxBuf[0]=0x61;
        tf=1;LED2_0;BELL_0; 
	}
    if(MARK==55)		//м7
	{
	TxBuf[0]=0x71;
        tf=1;LED1_1; BELL_1; 
        }
    if(MARK==56)		//м8
	{
	TxBuf[0]=0x81;
        tf=1;LED1_0;BELL_0; 
	}
//==================================================
   if(MARK==57)						//м9
	{
	TxBuf[0]=0x91;
        tf=1;LED1_1;BELL_0; 
        } 
//==============================================================================
    if (tf==1)                //յPCݺͨ RF24L01 ȥ 
       {	
            nRF24L01_TxPacket(TxBuf);	// Transmit Tx buffer data
            SPI_RW_Reg(WRITE_REG+STATUS,0XFF); 
	    tf = 0;MARK=0;
            TxBuf[0]=0x00; 
	   }

        }
      
}