
//-------------------------------------------------------------------------------------
//˿ڶ
#define IRQ					RC5				//ж
#define IRQ_T				TRISC5			//жϷ
#define nRF24L01_CE			RC3				//ʹܿ
#define nRF24L01_CE_T		TRISC3			//ʹܿƷ
#define nRF24L01_CSN		RC6				//Ƭѡ
#define nRF24L01_CSN_T		TRISC6			//ƬѡƷ
#define nRF24L01_MISO		RB4				//1׼
#define nRF24L01_MISO_T		TRISB4			//1׼÷
#define nRF24L01_SCK		RB6				//ʱ
#define nRF24L01_SCK_T		TRISB6			//ʱӷ
#define nRF24L01_MOSI		RC7				//
#define nRF24L01_MOSI_T		TRISC7			//ݷ


#define TX_ADR_WIDTH    5   // 5 bytes TX(RX) address width
#define TX_PLOAD_WIDTH  20  // 16 bytes TX payload


//****************************************************************//
// SPI(nRF24L01) commands
#define READ_REG        0x00  // Define read command to register
#define WRITE_REG       0x20  // Define write command to register
#define RD_RX_PLOAD     0x61  // Define RX payload register address
#define WR_TX_PLOAD     0xA0  // Define TX payload register address
#define FLUSH_TX        0xE1  // Define flush TX register command
#define FLUSH_RX        0xE2  // Define flush RX register command
#define REUSE_TX_PL     0xE3  // Define reuse TX payload register command
//#define NOP             0xFF  // Define No Operation, might be used to read status register

//***************************************************//
// SPI(nRF24L01) registers(addresses)
#define CONFIG          0x00  // 'Config' register address
#define EN_AA           0x01  // 'Enable Auto Acknowledgment' register address
#define EN_RXADDR       0x02  // 'Enabled RX addresses' register address
#define SETUP_AW        0x03  // 'Setup address width' register address
#define SETUP_RETR      0x04  // 'Setup Auto. Retrans' register address
#define RF_CH           0x05  // 'RF channel' register address
#define RF_SETUP        0x06  // 'RF setup' register address
#define STATUS          0x07  // 'Status' register address
#define OBSERVE_TX      0x08  // 'Observe TX' register address
#define CD              0x09  // 'Carrier Detect' register address
#define RX_ADDR_P0      0x0A  // 'RX address pipe0' register address
#define RX_ADDR_P1      0x0B  // 'RX address pipe1' register address
#define RX_ADDR_P2      0x0C  // 'RX address pipe2' register address
#define RX_ADDR_P3      0x0D  // 'RX address pipe3' register address
#define RX_ADDR_P4      0x0E  // 'RX address pipe4' register address
#define RX_ADDR_P5      0x0F  // 'RX address pipe5' register address
#define TX_ADDR         0x10  // 'TX address' register address
#define RX_PW_P0        0x11  // 'RX payload width, pipe0' register address
#define RX_PW_P1        0x12  // 'RX payload width, pipe1' register address
#define RX_PW_P2        0x13  // 'RX payload width, pipe2' register address
#define RX_PW_P3        0x14  // 'RX payload width, pipe3' register address
#define RX_PW_P4        0x15  // 'RX payload width, pipe4' register address
#define RX_PW_P5        0x16  // 'RX payload width, pipe5' register address
#define FIFO_STATUS     0x17  // 'FIFO Status Register' register address
#define MAX_RT  		0x10  	// Max #of TX retrans interrupt
#define TX_DS   		0x20  	// TX data sent interrupt
#define RX_DR   		0x40  	// RX data received
//-------------------------------------------
#define BIT(x)	           (1 << (x))
#define SETBIT(x, y)   	   (x |= y)
#define CLEARBIT(x, y) 	   (x &= ~y)
#define CHECKBIT(x, y) 	   (x & y)
#define BIT7 0x80
#define BIT6 0x40
#define BIT5 0x20
#define BIT4 0x10
#define BIT3 0x08
#define BIT2 0x04
#define BIT1 0x02
#define BIT0 0x01
/*
#define nRF24L01_CSN        BIT3
#define nRF24L01_SCK        BIT4
#define nRF24L01_MOSI       BIT5
#define nRF24L01_CE         BIT6
#define nRF24L01_MISO 	    BIT0
#define nRF24L01_IRQ  	    BIT1
*/
#define nRF24L01_CSNH       SETBIT(nRF24L01_PORT, nRF24L01_CSN)     //OUTPUT
#define nRF24L01_CSNL       CLEARBIT(nRF24L01_PORT, nRF24L01_CSN)   //OUTPUT

#define nRF24L01_SCKH       SETBIT(nRF24L01_PORT,nRF24L01_SCK)      //OUTPUT
#define nRF24L01_SCKL       CLEARBIT(nRF24L01_PORT,nRF24L01_SCK)    //OUTPUT

#define nRF24L01_MOSIP      CHECKBIT(nRF24L01_PORT,nRF24L01_MOSI)    //INTPUT

#define nRF24L01_CEH        CLEARBIT(nRF24L01_PORT,nRF24L01_CE)     //OUTPUT
#define nRF24L01_CEL        CLEARBIT(nRF24L01_PORT,nRF24L01_CE)     //OUTPUT

#define nRF24L01_MISOH      CLEARBIT(nRF24L011_PORT,nRF24L01_MISO)  //OUTPUT
#define nRF24L01_MISOL      CLEARBIT(nRF24L011_PORT,nRF24L01_MISO)  //OUTPUT

#define nRF24L01_IRQP       CHECKBIT(nRF24L01l_MISO,nRF24L01_IRQ)   //INPUT
//-------------------------------------------
//-------------------------------------------
/*
#define nRF24L01_PORT	  	PORTD
#define nRF24L01_DIR		DDRD
#define nRF24L01_IN		PIND
#define nRF24L011_PORT		PORTB
#define nRF24L011_DIR	        DDRB
#define nRF24L011_IN		PINB
*/

extern void RX_Mode(void);
extern void TX_Mode(void);

extern void nRF24L01ioConfig(void);//LCD initial IO.
extern unsigned char SPI_Write_Buf(unsigned char reg, unsigned char *pBuf, unsigned char bytes);
extern unsigned char SPI_Read_Buf(unsigned char reg, unsigned char *pBuf, unsigned char bytes);
extern unsigned char SPI_RW_Reg(unsigned char reg, unsigned char value);
extern unsigned char SPI_Read(unsigned char reg);
extern void nRF24L01_Interrupt(void);

extern unsigned char TX_ADDRESS[TX_ADR_WIDTH];
